/**
 * 
 */
package lm.parser;

import org.apache.log4j.Logger;

/**
 * @author Michal Jaros
 *
 */
public class InputString {

	/**
	 * Logger
	 */
	private static final Logger log = Logger.getLogger(InputString.class);

	/**
	 * 
	 */
	private String input = null;

	/**
	 * Bierzaca pozycja w lancuchu
	 */
	private int curentPosition = 0;

	/**
	 * @param input
	 */
	public InputString(String input){
		this.input = input.trim().replaceAll("\\s+", " ");
		curentPosition = 0;
	}

	/**
	 * @return the input
	 */
	public String getInput() {
		return input;
	}

	/**
	 * @param input the input to set
	 */
	public void setInput(String input) {
		curentPosition = 0;
		this.input = input;
	}

	/**
	 * @return
	 */
	public int length() {
		return input.length();
	}

	/**
	 * @return the curentPosition
	 */
	public int getCurentPosition() {
		return curentPosition;
	}

	/**
	 * @param curentPosition the curentPosition to set
	 */
	public void setCurentPosition(int curentPosition) {
		this.curentPosition = curentPosition;
	}

	/**
	 * @param token
	 * @return
	 */
	public boolean check(String token){
		token = token.trim();
		log.debug("Sprawdzam czy jest \"" + token + "\" (bierzaca pozycja " + (curentPosition+1) + ")");
		if (input.regionMatches(false, curentPosition, token, 0, token.length())){
			curentPosition += token.length();
			try {
				if (input.charAt(curentPosition) == ' '){
					curentPosition++;
				}
			}catch (StringIndexOutOfBoundsException e) {
			}
			log.debug("Token poprawnie dopasowany");
			return true;
		} else {
			log.warn("Na pozycji " + (curentPosition+1) + " oczekiwano tokenu \"" + token + "\"");
			return false;
		}
	}
}
